""" utility to print window properties set by main weather addon """

import os

import xbmcgui
import xbmc

import re


class PPrinter:
    def __init__( self, Addon ):
        # set Addon
        self.Addon = Addon

    def print_properties( self ):
        # get python source, we set properties in xbmcweather's weather.py file
        pySource = open( os.path.join( os.path.dirname( __file__ ), "weather.py" ), "r" ).read()
        # get properties and any description set by addon, we use a dict to eliminate duplicates
        properties = re.findall( "self.WINDOW.setProperty\(.*?\"([^\"]+)\".+#(?:\$GROUP\[([^\]]+)\])? (?:(.+))?", pySource )
        # add window properties header
        text = "\n%s\n%s Window Properties\n%s" % ( "-" * 150, self.Addon.getAddonInfo( "Name" ), "-" * 150, )
        # loop thru and add properties
        for property, group, description in properties:
            # 5 day future outlook
            if ( property.startswith( "Day%s" ) or property.startswith( "Night%s" ) ):
                property = property.replace( "%s", "<0-4>" )
                description = description.replace( "%s", "<0-4>" )
            # format property
            property = "Window(Weather).Property(%s)" % ( property, )
            if ( description != "" ):
                property = property + " "
                property = property.ljust( 60, "." )
            # group or subgroup
            if ( group ):
                group = [ "\n[%s]\n" % ( group, ), "\n" ][ group == "*" ]
            # append formatted line
            text += "%s%s %s\n" % ( group, property, description, )
        # add ending divider
        text += "%s\n" % ( "-" * 150, )
        # log properties for easy copying
        xbmc.log( text, level=xbmc.LOGNOTICE )
        # inform user
        ok = xbmcgui.Dialog().ok( self.Addon.getAddonInfo( "Name" ), self.Addon.getLocalizedString( 30700 ), os.path.join( xbmc.translatePath( "special://home/" ), "xbmc.log" ) )
